export interface ImmutableSetWrapper<T> {
    add: (value: T) => ImmutableSetWrapper<T>;
    addMany: (values?: T[]) => ImmutableSetWrapper<T>;
    delete: (value: T) => ImmutableSetWrapper<T>;
    deleteMany: (values?: T[]) => ImmutableSetWrapper<T>;
    clear: () => ImmutableSetWrapper<T>;
    unwrap: () => Set<T>;
}
export declare const ImmutableSetUtils: Readonly<{
    add: <T>(set: Set<T>, value: T) => Set<T>;
    delete: <T_1>(set: Set<T_1>, value: T_1) => Set<T_1>;
    clear: <T_2>(set: Set<T_2>) => Set<T_2>;
    wrap: <T_3>(set: Set<T_3>) => ImmutableSetWrapper<T_3>;
}>;
//# sourceMappingURL=immutableSet.d.ts.map